doit
Tool subclass: 'CodeBrowser'
	instVarNames: #( dictionary classCategory selectedClass
	                  isMeta methodCategory method)
	classVars: #()
	classInstVars: #()
	poolDictionaries: #()
	inDictionary: WebTools
	options: #()

%

! Remove existing behavior from CodeBrowser
doit
CodeBrowser removeAllMethods.
CodeBrowser class removeAllMethods.
%
! ------------------- Class methods for CodeBrowser
category: 'other'
set compile_env: 0
classmethod: CodeBrowser
description

	^'Browse SymbolDictionaries, Classes, and Methods'.
%
category: 'other'
set compile_env: 0
classmethod: CodeBrowser
displayName

	^'Code Browser'.
%
category: 'other'
set compile_env: 0
classmethod: CodeBrowser
sortOrder

	^3.
%
! ------------------- Instance methods for CodeBrowser
category: 'Public'
set compile_env: 0
method: CodeBrowser
json

	^Dictionary new
		at: 'dictList' 		put: self _browserDictList;
		at: 'classCatList'	put: self _browserClassCategoryList;
		at: 'classCat'		put: classCategory;
		at: 'classList'		put: self _browserClassList;
		at: 'class'			put: self _browserClass;
		at: 'newClass'		put: self _browserNewClassTemplate;
		at: 'categoryList'	put: self _browserCategoryList;
		at: 'category'		put: methodCategory;
		at: 'superList'		put: self _browserSuperList;
		at: 'methodList'	put: self _browserMethodList;
		at: 'method'		put: self _browserMethod;
		yourself.
%
category: 'Private'
set compile_env: 0
method: CodeBrowser
_browserCategoryList

	| selectedCategory list |
	selectedCategory := arguments at: 'category' ifAbsent: [nil].
	selectedCategory notNil ifTrue: [selectedCategory := selectedCategory asSymbol].
	methodCategory := nil.
	selectedClass isNil ifTrue: [^#()].
	list := selectedClass sortedCategoryNames.
	(list includes: selectedCategory) ifTrue: [methodCategory := selectedCategory].
	^list.
%
category: 'Private'
set compile_env: 0
method: CodeBrowser
_browserClass

	selectedClass isNil ifTrue: [^nil].
	^Dictionary new
		at: 'name' put: selectedClass thisClass name;
		at: 'definition' put: selectedClass thisClass definition;
		yourself.
%
category: 'Private'
set compile_env: 0
method: CodeBrowser
_browserClassCategoryList

	| selectedCategory set |
	selectedCategory := arguments at: 'classCat' ifAbsent: [nil].
	classCategory := nil.
	dictionary isNil ifTrue: [^#()].
	set := Set new.
	dictionary do: [:each | 
		each isClass ifTrue: [
			| category |
			category := each category.
			set add: category.
			(category notNil and: [category = selectedCategory or: [selectedCategory size <= category size and: [selectedCategory = (category copyFrom: 1 to: selectedCategory size)]]]) ifTrue: [classCategory := selectedCategory].
		].
	].
	^set asSortedCollection.
%
category: 'Private'
set compile_env: 0
method: CodeBrowser
_browserClassList

	| selectedOop list |
	selectedOop := (arguments at: 'class' ifAbsent: ['0']) asNumber.
	selectedClass := nil.
	dictionary isNil ifTrue: [^#()].
	list := dictionary select: [:each | 
		each isClass and: [
		| category |
		category := each category.
		classCategory isNil or: [category = classCategory or: [
		(category isKindOf: String) and: [(classCategory isKindOf: String) and: [
			classCategory size <= category size and: [classCategory = (category copyFrom: 1 to: classCategory size)]]]]]]
	].
	list := list asSortedCollection: [:a :b | a name <= b name].
	list := list collect: [:each | 
		| flag |
		(flag := each asOop == selectedOop) ifTrue: [
			selectedClass := (arguments at: 'isMeta' ifAbsent: ['']) = 'true' 
				ifTrue: [each class] 
				ifFalse: [each].
		].
		Dictionary new
			at: 'name'		put: each name;
			at: 'oop'			put: each asOop;
			at: 'selected'	put: flag;
			yourself.
	].
	^list.
%
category: 'Private'
set compile_env: 0
method: CodeBrowser
_browserDictList

	| selectedOop |
	selectedOop := (arguments at: 'dict' ifAbsent: ['0']) asNumber.
	dictionary := nil.
	^System myUserProfile symbolList collect: [:each | 
		| flag |
		(flag := each asOop == selectedOop) ifTrue: [dictionary := each].
		Dictionary new
			at: 'name'		put: each name;
			at: 'oop'			put: each asOop;
			at: 'selected'	put: flag;
			yourself.
	].
%
category: 'Private'
set compile_env: 0
method: CodeBrowser
_browserMethod

	method isNil ifTrue: [^nil].
	^Dictionary new
		at: 'name' put: method selector;
		at: 'source' put: method sourceString;
		yourself.
%
category: 'Private'
set compile_env: 0
method: CodeBrowser
_browserMethodList

	| selectedOop list |
	method := nil.
	selectedClass isNil ifTrue: [^#()].
	selectedOop := (arguments at: 'method' ifAbsent: ['0']) asNumber.
	list := methodCategory isNil
		ifTrue: [selectedClass selectors]
		ifFalse: [selectedClass selectorsIn: methodCategory].
	list := list asSortedCollection asArray.
	list := list collect: [:each | selectedClass compiledMethodAt: each].
	list := list collect: [:each | 
		each asOop == selectedOop ifTrue: [method := each].
		Dictionary new
			at: 'name'		put: each selector;
			at: 'oop'			put: each asOop;
			at: 'selected'	put: each asOop == selectedOop;
			yourself.
	].
	^list.
%
category: 'Private'
set compile_env: 0
method: CodeBrowser
_browserNewClassTemplate

	dictionary isNil ifTrue: [^nil].
	^
'Object subclass: ''MyNewClass''
	instVarNames: #( instVar1 instVar2 )
	classVars: #()
	classInstVars: #()
	poolDictionaries: #()
	inDictionary: ' , dictionary name , '
	options: #()'.
%
category: 'Private'
set compile_env: 0
method: CodeBrowser
_browserSuperList

	| list aClass |
	selectedClass isNil ifTrue: [^#()].
	list := OrderedCollection new.
	aClass := selectedClass.
	[
		aClass notNil.
	] whileTrue: [
		list add: aClass name.
		aClass := aClass superclass.
	].
	^list reverse.
%
doit
CodeBrowser category: 'WebTools'
%
