! file gscurrsession_2.gs
!  $Id$
!===================================================================================
category: 'Initialization'
method: GsCurrentSession
initialize

" This method is executed once at Session initialization,
  after the ProcessorScheduler is initialized.  It is invoked from
  ProcessorScheduler >> _initialize . 

  This method may be modified to invoke application specific 
  initialization code.  

  Use extreme caution when testing modifications to this method.
  Errors in this method may unrecoverably disable commits and
  require restore from backup.  Prior to testing modifications,
  make a full backup of your system.  During testing, disable
  execution of application specific code for user SystemUser to
  allow recovery.

  For example,

  (self userProfile userId = 'SystemUser') ifFalse: [
    [user code]
      on: (Globals at: #Error)
      do: [:ex | ex return]
    ].
"

"install a sessionMethodDictionary if GsPackagePolicy is enabled"
GsPackagePolicy ifNotNil:[ :policy | 
  policy loadSessionMethodDictionary.
].
^ self
%


